# import modulu pro želví grafiku
import turtle

#
# A) výpočet 4. generace Kochovy vločky
#

# startovní generace
stará_generace = 'F'

# výpočet několika nových generací
for i in range(1, 5):
    # výpočet jedné nové generace
    nová_generace = ''
    for znak in stará_generace:
        match znak:
            case 'F':
                nová_generace += 'F+F--F+F'
            case _:     # všechny ostatní znaky zkopíruj
                nová_generace += znak
    print(i, ':', nová_generace)
    # prohození generací v proměnných pro potřeby výpočtu
    stará_generace = nová_generace

#
# B) vykreslení 4. generace Kochovy vločky
#

# posun želvy do lepší startovní pozice
turtle.teleport(-300, 0)

# rychlejší kreslení
turtle.speed(0)

# předpis pro kreslení
předpis = nová_generace

# smyčka, která prochází předpis znak po znaku (tedy příkaz po příkazu)
for znak in předpis:
    match znak:
        case 'F':
            turtle.forward(10)      # 10 kroků dopředu
        case '+':
            turtle.left(60)         # otočení o 60° doleva
        case '-':
            turtle.right(60)        # otočení o 60° doprava

# hlavní čekací smyčka GUI
turtle.mainloop()
